package com.engine.organization.service;

import com.engine.organization.entity.fieldset.vo.TypeTreeVO;
import com.engine.organization.entity.scheme.param.SchemeSearchParam;
import com.engine.organization.util.MenuBtn;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @Author dxfeng
 * @description:
 * @Date 2022/5/9
 * @Version V1.0
 **/
public interface SchemeService {

    /**
     * 等级方案列表
     *
     * @param params
     * @return
     */
    Map<String, Object> listPage(Map<String, Object> params);

    /**
     * 新增等级方案
     *
     * @param param
     * @return
     */
    int save(SchemeSearchParam param);

    /**
     * 更新等级方案信息
     *
     * @param param
     * @return
     */
    int updateScheme(SchemeSearchParam param);

    /**
     * 更新禁用标记
     *
     * @param params
     * @return
     */
    int updateForbiddenTagById(SchemeSearchParam params);

    /**
     * 根据ID批量删除等级方案信息
     *
     * @param ids
     * @return
     */
    int deleteByIds(Collection<Long> ids);

    /**
     * 获取搜索条件
     *
     * @param params
     * @return
     */
    Map<String, Object> getSearchCondition(Map<String, Object> params);


    /**
     * 获取新增表单
     *
     * @param params
     * @return
     */
    Map<String, Object> getSchemeForm(Map<String, Object> params);

    /**
     * 获取列表页面按钮信息
     *
     * @return
     */
    Map<String, List<MenuBtn>> getTableBtn();

    /**
     * 获取左侧树
     *
     * @return
     */
    List<TypeTreeVO> getTreeData();

}
